<?php
namespace bwdsb_switch_background_namespace;

define( "BWDSB_ASFSK_ASSETS_PUBLIC_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/public" );
define( "BWDSB_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );
class Classbwdsb_switch_background {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function bwdsb_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'bwdsb_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function bwdsb_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'bwdsb_switchbackground_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/bwdsb-switchBackground-widgets.php' );
	}

	public function bwdsb_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register WidgetsF
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\bwdsb_switchbackground_widgets());
	}

	// Register Category
	function bwdsb_switchbackground_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'bwdsb-switch-background-category',
			[
				'title' => esc_html__( 'Background Switcher', 'bwdsb-switch-backgroundtd' ),
				'icon' => 'eicon-person',
			]
		);
	}

	//css-js-link-here
	public function bwdsb_all_assets_for_the_public(){

		wp_enqueue_script( 'switchbackground-main', plugin_dir_url( __FILE__ ) . 'assets/public/js/main.js', array('jquery'), '1.3', true );

		$all_css_file = array(

            'switchbackground-plugin-animate' => array('bwdsb_switchbackground_css_path_define'=>BWDSB_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/animate.min.css'),

            'switchbackground-plugin-main' => array('bwdsb_switchbackground_css_path_define'=>BWDSB_ASFSK_ASSETS_PUBLIC_DIR_FILE . '/css/main.css'),


        );
        foreach($all_css_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdsb_switchbackground_css_path_define'], null, '1.3', 'all');
        }

	}

	//admin-icon
	public function bwdsb_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'switchbackground-admin-main' => array('bwdsb_path_admin_define'=>BWDSB_ASFSK_ASSETS_ADMIN_DIR_FILE . '/css/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['bwdsb_path_admin_define'], null, '1.3', 'all');
        }
	}
	
	public function __construct() {

		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'bwdsb_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'bwdsb_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'bwdsb_switchbackground_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'bwdsb_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'bwdsb_admin_editor_scripts' ] );
	}
}

// Instantiate Plugin Class
Classbwdsb_switch_background::instance();